using System;

namespace Kvalifikacije_2_E_18._12._2021
{
    class Program
    {
        static void Main(string[] args)
        {
            int n, k;
            string[] s = Console.ReadLine().Split();
            n = int.Parse(s[0]);
            k = int.Parse(s[1]);
            int po=0,kr=n-1,br=0,max=0;
            s = Console.ReadLine().Split();
            int[] a = new int[n];
            while (br != n)
            {
                a[br] = int.Parse(s[br]);
                br++;
            }
            while (k > 1)
            {                
                if (a[po] == 0)
                    po++;
                else if (a[kr] == 0)
                    kr--;
                else if (k > 1)
                {
                    if (a[po] > a[kr])
                    {
                        a[kr] = a[kr] - a[po];
                        po++;
                    }
                    else
                    {
                        a[po] = a[po] - a[kr];
                        kr--;
                    }
                }
                else
                {
                    if (a[po] < a[kr])
                    {
                        a[kr] = a[kr] - a[po];
                        po++;
                    }
                    else
                    {
                        a[po] = a[po] - a[kr];
                        kr--;
                    }
                }
                k=k-2;
            }
            while(po!=kr+1)
            {
                max = Math.Max(max, a[po]);
                po++;
            }
            Console.WriteLine(max);
        }
    }
}